//+------------------------------------------------------------------+
//|                                                   XDemark_BB.mq5 | 
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
//|                                                                  |
//|     SmoothAlgorithms.mqh                  |
//|    : __\\MQL5\Include |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----    10
#property indicator_buffers 10 
//----  8  
#property indicator_plots   8
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_LINE
//----      
#property indicator_color1 Gray,Lime,Orange
//----   - 
#property indicator_style1 STYLE_DASHDOTDOT
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "Signal line"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//----     
#property indicator_type2 DRAW_LINE
//----      
#property indicator_color2 Gray
//----   - 
#property indicator_style2 STYLE_SOLID
//----     1
#property indicator_width2 1
//----   
#property indicator_label2 "XDemark line"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//----      
#property indicator_type3 DRAW_COLOR_ARROW
//----     
#property indicator_color3 Gray,Green,Blue,Red,Magenta
//----   -  
#property indicator_style3 STYLE_SOLID
//----     3
#property indicator_width3 3
//----   
#property indicator_label3 "XDemark arrow"
//+--------------------------------------------+
//|     BB  |
//+--------------------------------------------+
//----      
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
#property indicator_type7   DRAW_LINE
#property indicator_type8   DRAW_LINE
//----    
#property indicator_color4  Blue
#property indicator_color5  Red
#property indicator_color6  Gray
#property indicator_color7  Red
#property indicator_color8  Blue
//----   -  
#property indicator_style4 STYLE_DASHDOTDOT
#property indicator_style5 STYLE_DASHDOTDOT
#property indicator_style6 STYLE_DASHDOTDOT
#property indicator_style7 STYLE_DASHDOTDOT
#property indicator_style8 STYLE_DASHDOTDOT
//----     1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1
//----    
#property indicator_label4  "+2Sigma"
#property indicator_label5  "+Sigma"
#property indicator_label6  "Middle"
#property indicator_label7  "-Sigma"
#property indicator_label8  "-2Sigma"
//+------------------------------------------+
//      |
//+------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//----    CXMA  CStdDeviation   SmoothAlgorithms.mqh
CXMA UPXDemark,DNXDemark,XSIGN,XMA;
CStdDeviation STD;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_     //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -    SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method DSmoothMethod=MODE_JurX; //   
input int DPeriod=14;                        //  
input int DPhase=100;                        //   
input Smooth_Method SSmoothMethod=MODE_JJMA; //    
input int SPeriod=12;                        //   
input int SPhase=100;                        //   
input Applied_price_ IPC=PRICE_CLOSE;        //  
input int Shift=0;                           //      
input int BBPeriod=100;                      //    
input double BBDeviation1 = 1.0;             //   
input double BBDeviation2 = 1.6;             //   
//+-----------------------------------+
//----   ,   
//----      
double XDemark[],XDemarkLine[],XXDemark[];
double ColorXDemark[],ColorXXDemark[];
double ExtLineBuffer1[],ExtLineBuffer2[],ExtLineBuffer3[],ExtLineBuffer4[],ExtLineBuffer5[];
//----     
double quotient;
//----      
int min_rates_total,min_rates_totalD,min_rates_totalS,min_rates_totalB;
//+------------------------------------------------------------------+   
//| XDemark indicator initialization function                        | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_totalD=UPXDemark.GetStartBars(DSmoothMethod,DPeriod,DPhase)+1;
   min_rates_totalS=min_rates_totalD+UPXDemark.GetStartBars(SSmoothMethod,SPeriod,SPhase);
   min_rates_totalB=min_rates_totalD+BBPeriod;
   min_rates_total=MathMax(min_rates_totalS,min_rates_totalB);
//----       
   UPXDemark.XMALengthCheck("DPeriod", DPeriod);
   UPXDemark.XMALengthCheck("SPeriod", SPeriod);
//----       
   UPXDemark.XMAPhaseCheck("DPhase",DPhase,DSmoothMethod);
   UPXDemark.XMAPhaseCheck("SPhase",SPhase,SSmoothMethod);
//----     
   quotient=BBDeviation2/BBDeviation1;
//----    XXDemark[]   
   SetIndexBuffer(0,XXDemark,INDICATOR_DATA);
//----    2  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_totalS+1);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    ColorXXDemark[]       
   SetIndexBuffer(1,ColorXXDemark,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_totalS+1);

//----    XDemarkLine[]   
   SetIndexBuffer(2,XDemarkLine,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_totalD);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    XDemark[]   
   SetIndexBuffer(3,XDemark,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_totalD+1);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    ColorXDemark[]       
   SetIndexBuffer(4,ColorXDemark,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_totalD+1);

//----      
   SetIndexBuffer(5,ExtLineBuffer1,INDICATOR_DATA);
   SetIndexBuffer(6,ExtLineBuffer2,INDICATOR_DATA);
   SetIndexBuffer(7,ExtLineBuffer3,INDICATOR_DATA);
   SetIndexBuffer(8,ExtLineBuffer4,INDICATOR_DATA);
   SetIndexBuffer(9,ExtLineBuffer5,INDICATOR_DATA);
//----  ,      
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,min_rates_totalB);
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,min_rates_totalB);
   PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,min_rates_totalB);
   PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,min_rates_totalB);
   PlotIndexSetInteger(9,PLOT_DRAW_BEGIN,min_rates_totalB);
//----      
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(7,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(8,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(9,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   string shortname,Smooth;
   Smooth=UPXDemark.GetString_MA_Method(DSmoothMethod);
   StringConcatenate(shortname,"XDemark(",string(DPeriod),",",Smooth,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+ 
//| XDemark iteration function                                       | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----       
   double up_demark,dn_demark,up_xdemark,dn_xdemark,xdemark,xxdemark,xma,stdev1,stdev2;
//----        
   int first1,first2,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first1=1;                  //      
      first2=min_rates_totalS+1;
     }
   else
     {
      first1=prev_calculated-1; //      
      first2=first1;
     }

//----    
   for(bar=first1; bar<rates_total; bar++)
     {
      if(high[bar]>high[bar-1]) up_demark=high[bar]-high[bar-1]; else up_demark=0.0;
      if(low [bar]<low [bar-1]) dn_demark=low [bar-1]-low[bar];  else dn_demark=0.0;

      //----    XMASeries 
      up_xdemark=UPXDemark.XMASeries(1,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,up_demark,bar,false);
      dn_xdemark=DNXDemark.XMASeries(1,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,dn_demark,bar,false);

      dn_xdemark+=up_xdemark;
      if(dn_xdemark!=0) xdemark=up_xdemark/dn_xdemark;
      else xdemark=EMPTY_VALUE;

      //----      
      XDemark[bar]=xdemark;
      XDemarkLine[bar]=xdemark;

      //----   
      xxdemark=XSIGN.XMASeries(min_rates_totalD,prev_calculated,rates_total,SSmoothMethod,SPhase,SPeriod,xdemark,bar,false);

      //----      
      XXDemark[bar]=xxdemark;

      //----         
      xma=XMA.XMASeries(min_rates_totalD+1,prev_calculated,rates_total,MODE_SMA_,0,BBPeriod,xdemark,bar,false);
      stdev1=STD.StdDevSeries(min_rates_totalB,prev_calculated,rates_total,BBPeriod,BBDeviation1,xdemark,xma,bar,false);
      stdev2=stdev1*quotient;
      //---- 
      if(bar<=min_rates_totalB+BBPeriod)
        {
         xma=EMPTY_VALUE;
         stdev1=0.0;
         stdev2=0.0;
        }

      ExtLineBuffer1[bar]=xma+stdev2;
      ExtLineBuffer2[bar]=xma+stdev1;
      ExtLineBuffer3[bar]=xma;
      ExtLineBuffer4[bar]=xma-stdev1;
      ExtLineBuffer5[bar]=xma-stdev2;
     }

//----     XDemark
   for(bar=first2; bar<rates_total; bar++)
     {
      ColorXDemark[bar]=0;

      if(XDemark[bar]>ExtLineBuffer3[bar])
        {
         if(XDemark[bar]>XDemark[bar-1]) ColorXDemark[bar]=1;
         if(XDemark[bar]<XDemark[bar-1]) ColorXDemark[bar]=2;
        }

      if(XDemark[bar]<ExtLineBuffer3[bar])
        {
         if(XDemark[bar]<XDemark[bar-1]) ColorXDemark[bar]=3;
         if(XDemark[bar]>XDemark[bar-1]) ColorXDemark[bar]=4;
        }
     }

//----      XXDemark
   for(bar=first2; bar<rates_total; bar++)
     {
      ColorXXDemark[bar]=0;
      if(XDemark[bar]>XXDemark[bar-1]) ColorXXDemark[bar]=1;
      if(XDemark[bar]<XXDemark[bar-1]) ColorXXDemark[bar]=2;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
